const tool = require('curl-ganteng');
const parser = require('./parser');
const Cacheman = require('cacheman');
let cache = new Cacheman({engine: 'file', ttl: 1800});
const Stream = function (vid = false) {
  if(vid) this.vid = vid;
}

Stream.prototype.setCookie = function (cookie) {
  this.cookie = cookie;
}

Stream.prototype.setVid = function (vid) {
  this.vid = vid;
}

Stream.prototype.setUsername = function (username) {
  this.username = username;
}

Stream.prototype.setUrl = function (url) {
  this.url = url;
}

Stream.prototype.get = function () {
  let current = this;
  return cache.get(current.vid)
    .then(function (value) {
      if(value) return new Promise((resolve, reject) => {resolve(value)});
      if(!current.username) throw {error: true, message: `Please set username`};
      let link = current.url ? current.url : current.vid ? `https://www.facebook.com/${current.username}/videos/${current.vid}/` : false;
      if(!link) throw({error: true, message: 'Please provide link or video ID'});
      return tool.curl(link, {cookie: current.cookie})
        .then((res) => {
          return res;
        })
        .then(parser.video).then((result) => {
          cache.set(current.vid, result, (err, done) => {
            if(err) console.log(`cant save cache ${current.vid}`);
          })
          return result;
        });
    });
}

module.exports = Stream;
